# ***************************************************
### LIBRERÍAS R NECESARIAS PARA USAR ESTAS FUNCIONES
### INSTALARLAS PREVIAMENTE (ejecutar la siguiente 
###       línea en la consola)
### install.packages(c("exams","xfun","stringr","glue"))
### 
# ***************************************************

library(xfun)
library(stringr)
library(glue)
library(exams)
oopt <- options(device.ask.default = FALSE, exams_tex = "tools")



# ***************************************************
### función para latex a img con tex2image
### Mejorable
###
### 
### 
# ***************************************************


func_latex_to_img = function(clatex, name = "prueba", format=NULL, 
                             markup = "tex",width=NULL) {
  #width = "2cm"
  tikz = clatex
  library = NULL
  tex2image(tikz, name = name, dir = ".", format = format, 
            tikz = library, show = FALSE)
  fig <- paste(name, format, sep = ".")
  if (markup == "tex") {
    writeLines(sprintf("\\includegraphics[width='%s']{%s}", width, 
                       fig))
    invisible(fig)
  } else if (markup == "markdown") {
    writeLines(sprintf("![](%s){width=%s}", fig, width))
    invisible(fig)
  } else {
    return(fig)
  }
  
}


# ***************************************************
# ***************************************************


# ***************************************************
### función para latex a img con texPreview
### Mejor pero puedo mejorar la salida latex 
### no usa \includegraphics[??]{fichero.png}
### 
### 
# ***************************************************

func_latex_a_imagen_texpreview = function(clatex,fichero="prueba",
                                          fmt_salida="html",resizebox = TRUE) {
  
  fichero.ext = paste0(fichero,".png")  
  fichero2 = texPreview::tex_preview(clatex,stem=fichero,fileDir=".",
                                     returnType="tex",imgFormat="png",
                                     resizebox = resizebox)
  b=exams::include_supplement(fichero.ext,dir = ".")
  if ((fmt_salida=="html") | (fmt_salida=="latex")) {
    knitr::include_graphics(fichero.ext)
  } else {
    scad = paste0('![](',fichero.ext,')')
    #cat('![](prueba3.png)')  
    cat(scad)
  }  
}



# ***************************************************
# ***************************************************



# fic = read_utf8("lista01.Rmd")
# #fic
# #s1 = str_extract_all(fic,"# Pregunta",simplify = T)
# 
# PR_posini = which(str_detect(fic,pattern = "# Pregunta"))
# PR_cuantas = length(PR_posini)
# PR_en = vector(mode="character",PR_cuantas)
# PR_tipo = vector(mode="character",PR_cuantas)
# for (i in 1:(PR_cuantas-1)) {
#   
#   s1 = fic[PR_posini[i]]
#   PR_tipo[i] = "schoice"
#   if (str_detect(s1,fixed("(num)"))) {
#     PR_tipo[i] = "num"
#   }
#   PR_en[i] = paste(fic[(PR_posini[i]+1):(PR_posini[i+1]-1)],collapse = "\n")
# }
# 
# i = 14
# s1 = fic[PR_posini[i]]
# PR_tipo[i] = "schoice"
# if (str_detect(s1,fixed("(num)"))) {
#   PR_tipo[i] = "num"
# }
# PR_en[i] = paste(fic[(PR_posini[i]+1):length(fic)],collapse = "\n")
# 
# 
# cat(PR_en[13])
# 
# cat(PR_en[14])
# cat(PR_tipo[14])
# PR_tipo

# Uno de tipo "schoice"

# ENUN = PR_en[14]
# 
# nbfileQ = paste0("QPreg",ii,"nn.Rmd")
# func_Rexams_crea_schoice(ENUN,nbfileQ)
# func_Rexams_crea_schoice(PR_en[13],nbfileQ=paste0("QPreg",22,"nn.Rmd"))

# ***************************************************
### función para crear ficheros con preguntas schoice
### 
### arg1: 
### arg2: 
### 
# ***************************************************

func_Rexams_crea_schoice = function(ENUN,nbfileQ,Qnombre="Ejercicio 1") {
  #str_split_fixed(ENUN,"\\n",n = 10)
  vlineas = str_split(ENUN,"\\n",simplify = TRUE)
  #EN_posini = which()
  idopcsF = which(str_detect(vlineas,pattern = "^- "))
  vopcsF = vlineas[idopcsF]
  idopcsV = which(str_detect(vlineas,pattern = "^[+] "))
  vopcsV = vlineas[idopcsV]
  
  posf = min(c(idopcsF,idopcsV))
  enunc = paste(vlineas[1:posf-1],collapse = "\n")
  #cat(enunc)
  
  #ii = 14              
  #Mnombre = paste0("Preg ",ii," nueva")
  Mnombre = Qnombre
  nrespF = length(vopcsF)
  nrespV = length(vopcsV)
  Msol = paste0(c(rep(1,nrespV),rep(0,nrespF)),collapse="")
  Msuf = nrespV+nrespF
  
  Qini = '
Question
========

'
  
  Qopc = '  
Answerlist
----------
  
'  
  
  Qmet = '

Meta-information
================
exname: {Mnombre}
extype: schoice
exsolution: {Msol}
exshuffle: {Msuf}
'
  
  Qmet2 = glue(Qmet)
  
  vopcsF = vlineas[idopcsF]
  vopcsV = vlineas[idopcsV]
  
  vopcsF2 = str_remove(vopcsF,pattern = "^- ")
  vopcsV2 = str_remove(vopcsV,pattern = "^[+] ")
  QopcV = paste0("* ",vopcsV2,collapse = "\n")
  QopcF = paste0("* ",vopcsF2,collapse = "\n")
  
  
  Qfin = paste0(Qini,
                enunc,       
                Qopc,
                QopcV,
                "\n",
                QopcF,
                "\n\n",
                Qmet2,
                collapse="\n")
  #cat(Qfin)
  
  # nbfileQ = paste0("QPreg",ii,".Rmd")
  write_utf8(Qfin,nbfileQ)
  
}


# Ej de uso

# ***************************************************
# ***************************************************


# # todos schoice menos 4 y 6
# lschoice = which(PR_tipo=="schoice")
# for (i in 1:length(lschoice)) {
#   ii = lschoice[i]
#   ENUN = PR_en[ii]
#   nbfileQ = paste0("QPreg",ii,"_schoice.Rmd")
#   Qnombre = paste0("QPreg",ii)
#   func_Rexams_crea_schoice(ENUN,nbfileQ,Qnombre)
#   #func_Rexams_crea_schoice(PR_en[13],nbfileQ=paste0("QPreg",22,"nn.Rmd"))
# }
# 

# ENUN = PR_en[4]
# cat(ENUN)
# ***************************************************
### función para crear ficheros con preguntas num
### 
### arg1: 
### arg2: 
### 
# ***************************************************

func_Rexams_crea_num = function(ENUN,nbfileQ,Qnombre="Ejercicio 1",QMtol="0.01") {
  #str_split_fixed(ENUN,"\\n",n = 10)
  vlineas = str_split(ENUN,"\\n",simplify = TRUE)
  #EN_posini = which()
  idresp = which(str_detect(vlineas,pattern = "^- Respuesta: "))
  resp = vlineas[idresp]
  Msol = str_remove(resp,pattern = "^- Respuesta: ")
  enunc = paste(vlineas[1:(idresp-1)],collapse = "\n")
  
  #ii = 14              
  #Mnombre = paste0("Preg ",ii," nueva")
  Mtol = QMtol
  Mnombre = Qnombre
  Qsol = Msol
  
  
  
  Qini = paste0('
```{r, echo=FALSE, results="hide"}
## parametros
# a <- sample(2:9, 1)
# b <- sample(seq(2, 4, 0.1), 1)
# c <- sample(seq(0.5, 0.8, 0.01), 1)
## solucion
res <- ', Qsol, '
```

  
Question
========

')
  
  
  Qmet = '

Meta-information
================
extype: num
exsolution: `r exams::fmt(res)`
exname: {Mnombre}
extol: {Mtol}
'
  
  Qmet2 = glue(Qmet)
  
  
  Qfin = paste0(Qini,
                enunc,       
                "\n\n",
                Qmet2,
                collapse="\n")
  #cat(Qfin)
  
  # nbfileQ = paste0("QPreg",ii,".Rmd")
  write_utf8(Qfin,nbfileQ)
  
}


# Ej de uso

# ***************************************************
# ***************************************************


# todos schoice menos 4 y 6
# lschoice = which(PR_tipo=="num")
# for (i in 1:length(lschoice)) {
#   #ii = 7
#   ii = lschoice[i]
#   ENUN = PR_en[ii]
#   nbfileQ = paste0("QPreg",ii,"_num.Rmd")
#   Qnombre = paste0("QPreg",ii)
#   func_Rexams_crea_num(ENUN,nbfileQ,Qnombre)
#   #func_Rexams_crea_schoice(ENUN,nbfileQ,Qnombre)
#   #func_Rexams_crea_schoice(PR_en[13],nbfileQ=paste0("QPreg",22,"nn.Rmd"))
# }
# 



# ***************************************************
### función para importar preguntas R/exams de un fichero Rmd
### con: 
### # Preguntas 
### # Preguntas (num)
### 
### arg1: nombre del fichero Rmd que tiene las preguntas (ver modelo: lista01.Rmd) 
### arg2: raíz del nombre que se colocará a cada uno de los ejercicios
### 
# ***************************************************
func_Rexams_extrae_Preguntas = function(nfileRmd,QraizNb="QPreg",donde=NULL) {
  
  #fic = read_utf8("lista01.Rmd")
  fic = read_utf8(nfileRmd)
  #fic
  #s1 = str_extract_all(fic,"# Pregunta",simplify = T)
  
  PR_posini = which(str_detect(fic,pattern = "# Pregunta"))
  PR_cuantas = length(PR_posini)
  PR_en = vector(mode="character",PR_cuantas)
  PR_tipo = vector(mode="character",PR_cuantas)
  PR_nbfiles = vector(mode="character",PR_cuantas)
  for (i in 1:(PR_cuantas-1)) {
    
    s1 = fic[PR_posini[i]]
    PR_tipo[i] = "schoice"
    if (str_detect(s1,fixed("(num)"))) {
      PR_tipo[i] = "num"
    }
    PR_en[i] = paste(fic[(PR_posini[i]+1):(PR_posini[i+1]-1)],collapse = "\n")
  }
  
  i = PR_cuantas
  s1 = fic[PR_posini[i]]
  PR_tipo[i] = "schoice"
  if (str_detect(s1,fixed("(num)"))) {
    PR_tipo[i] = "num"
  }
  PR_en[i] = paste(fic[(PR_posini[i]+1):length(fic)],collapse = "\n")
  
  # todos schoice 
  lschoice = which(PR_tipo=="schoice")
  for (i in 1:length(lschoice)) {
    ii = lschoice[i]
    ENUN = PR_en[ii]
    nbfileQ = paste0(QraizNb,ii,"_schoice.Rmd")
    if (!is.null(donde)) {
      nbfileQ = paste0(donde,nbfileQ)
    }
    PR_nbfiles[ii] = nbfileQ
    Qnombre = paste0(QraizNb,ii)
    func_Rexams_crea_schoice(ENUN,nbfileQ,Qnombre)
    #func_Rexams_crea_schoice(PR_en[13],nbfileQ=paste0("QPreg",22,"nn.Rmd"))
  }
  
  
  # todos num
  lschoice = which(PR_tipo=="num")
  for (i in 1:length(lschoice)) {
    ii = lschoice[i]
    ENUN = PR_en[ii]
    nbfileQ = paste0(QraizNb,ii,"_num.Rmd")
    if (!is.null(donde)) {
      nbfileQ = paste0(donde,nbfileQ)
    }
    PR_nbfiles[ii] = nbfileQ
    Qnombre = paste0(QraizNb,ii)
    func_Rexams_crea_num(ENUN,nbfileQ,Qnombre)
    #func_Rexams_crea_schoice(PR_en[13],nbfileQ=paste0("QPreg",22,"nn.Rmd"))
  }
  
  return(PR_nbfiles)
}

# Ej de uso
# nbsfiles = func_Rexams_extrae_Preguntas(nfileRmd="lista01.Rmd",QraizNb="AQPreg")
# #nbtodos = paste0(nbsfiles,collapse=",")
# exams2html(nbsfiles)
# ***************************************************
# ***************************************************





