library(tidyverse,warn.conflicts = FALSE)
library(exams)


# Función para generar datos para problemas de fecundidad ----------
fun_gen_Datos_Prob_Fecundidad = function(
  Pob.Total.Mujeres = 10418965,
  semilla = 1) {
  if (!is.null(semilla)) {
    set.seed(semilla)
  }  
  #### Iniciales
  #Pob_Tot_Muj = 10418965
  Pob_Tot_Muj = Pob.Total.Mujeres
  #nLx_inicial = 496356
  #nLx_inicial = 496356 + sample(seq(-10000,1000,by=10),1)
  nLx_inicial = round(496356 + runif(1,-10000,1000),0)
  #Total.Nac = 379111
  #Total.Nac = as.integer(round(Pob_Tot_Muj / sample(seq(24.0,29.0,by=0.1),1),0))
  #Total.Nac = as.integer(round(Pob_Tot_Muj * sample(seq(0.0065,0.0495,by=0.0001),1),0))
  Total.Nac = as.integer(round(Pob_Tot_Muj * runif(1,0.0065,0.0395),0))
  #Total.Nac = Total.Nacimientos
  #Total.Nac.Muj = 183919
  #Total.Nac.Muj = as.integer(round(Total.Nac * sample(seq(0.46,0.50,by=0.001),1),0))
  Total.Nac.Muj = as.integer(round(Total.Nac * runif(1,0.46,0.50) ,0))
  
  Gmod = sample(3,1)
  Porc.NacGrEdad = switch (Gmod,
          c(3,10,29,39,16,2,1),
          c(10,20,30,50,30,10,2),
          c(3,5,30,50,40,20,2)
  )
  #Porc.NacGrEdad = c(3,10,29,39,16,2,1)
  #Porc.NacGrEdad = c(10,20,30,50,30,10,2)
  
  Porc.NacGrEdad = round((Porc.NacGrEdad/sum(Porc.NacGrEdad))*100,0)
  Pvar = (2/100)
  #### Generados
  Gedad.iz = as.integer(seq(15,49,by=5))
  Gedad.de = as.integer(seq(19,49,by=5))
  Gedad_s = paste(Gedad.iz,Gedad.de,sep="-")
  Gngrupos = length(Gedad_s)
  Total.Nac.Hom = Total.Nac - Total.Nac.Muj
  Gsalto = 2
  Gen.2g = sample(Gngrupos-Gsalto,2)+round(Gsalto/2,0)
  Suma.2g = sum(Porc.NacGrEdad[Gen.2g])
  Gen.2ga = sample(round(Suma.2g/4,0),1)
  e1 = max(Porc.NacGrEdad[Gen.2g])-Gen.2ga
  e2 = Suma.2g - e1
  Porc.NacGrEdad[Gen.2g] =  sample(c(e1,e2),2)
  PorcHom = seq(48,55,by=0.01)
  Porc.HomTotal = sample(PorcHom,Gngrupos)
  #Porc.NacGrEdad
  #sum(Porc.NacGrEdad)
  #Porc.NacGrEdad = round((Porc.NacGrEdad/sum(Porc.NacGrEdad))*100,0)
  #8878/Total.Nac
  tb_Nac = tibble(
    GEdad = Gedad_s,
    Nac.Tot = as.integer(round(Total.Nac * (Porc.NacGrEdad/100),0)),
    GEdad.iz = Gedad.iz,               
    GEdad.de = Gedad.de
  ) %>% 
    mutate(
      Nac.Hom = as.integer(round(Nac.Tot*(Porc.HomTotal/100),0)),
      Nac.Muj = Nac.Tot - Nac.Hom,
    ) %>% 
    select(GEdad,GEdad.iz,GEdad.de,Nac.Tot,Nac.Hom,Nac.Muj)
  
  #tb_Nac
  
  
  Pob_Muj_Edad = rep(NA,Gngrupos)
  DivGngrupos = round(Pob_Tot_Muj/Gngrupos,0)
  PorcPob = round(100/Gngrupos,0)
  G3 = sample(30,4)/100
  G3ma = 1 + G3
  indtodos = 1:Gngrupos
  i1 = round(quantile(indtodos,0.1),0)
  Gcen = i1:(i1+3)
  #setdiff()
  Pob_Muj_Edad[Gcen] = DivGngrupos*G3ma
  G3b = 1-sum(G3)/(Gngrupos-4)
  G3mi = 1 - G3b
  Pob_Muj_Edad[-Gcen] = DivGngrupos*G3mi
  
  tb_Pob_Muj = tibble(
    GEdad = Gedad_s,
    Pob.t = as.integer(Pob_Muj_Edad)
  ) %>% 
    mutate(
      Pob.t1 = as.integer(   Pob.t * ((100+sample(seq(-3,10,by=0.01),Gngrupos))/100))
    )
  #tb_Pob_Muj
  
  Pvari = round(Pvar/Gngrupos,4)
  Pvari1 = Pvari + sample(seq(-0.0020,0.0020,by=0.0001),Gngrupos)
  Pvari2 = 1-cumsum(Pvari1)
  
  
  tb_nLx_Muj = tibble(
    GEdad = Gedad_s,
    nLx = as.integer(round(nLx_inicial*Pvari2,0))
  ) 
  #tb_nLx_Muj

  tb_psuperv_Muj = tibble(
    GEdad = Gedad_s,
    psupx = round((nLx_inicial*Pvari2)/500000,5)
  ) 
  
  MulPob = sample(seq(3.8,4.5,by=0.1),2)
  
  Val1 = round(sum(tb_Pob_Muj$Pob.t)  * MulPob[1],0)
  Val2 = round(sum(tb_Pob_Muj$Pob.t1) * MulPob[2],0)
  
    # tb_Nacim = tb_Nac
    # tb_Pob_Muj = tb_Pob_Muj
    # Pob_Total_t = as.integer( Val1 )
    # Pob_Total_t1 = as.integer( Val2 )
    # tb_nLx_Muj = tb_nLx_Muj

  res = list(
    tb_Nacim = tb_Nac,
    tb_Pob_Muj = tb_Pob_Muj,
    Pob_Total_t = as.integer( Val1 ),
    Pob_Total_t1 = as.integer( Val2 ),
    tb_nLx_Muj = tb_nLx_Muj,
    tb_psuperv_Muj = tb_psuperv_Muj
  )
  return(res)
  
}

#ej1 = fun_gen_Datos_Prob_Fecundidad()

# Función que resuelve el problema del ejercicio 1 de fecundidad ------
func_temaFec_ejerc01 = function(l_tbs_Fec_ej01) {
  
  ltbs = l_tbs_Fec_ej01
  
  ltbs2 = dplyr::bind_cols(ltbs$tb_Nacim,ltbs$tb_Pob_Muj %>% select(-1),ltbs$tb_nLx_Muj %>% select(-1))
  
  
  tb_TEF = ltbs2 %>% 
    mutate(
      Marcasx = round2( (GEdad.iz+GEdad.de+1)/2 , 1),
      PMediaMujx = round2( (Pob.t+Pob.t1)/2, 2),
      TEFx1000 = round2( (Nac.Tot/PMediaMujx) * 1000, 2),
      TEFfx1000 = round2( (Nac.Muj/PMediaMujx) * 1000, 2)
    ) %>% 
    select(-2,-3,-5)
  
  PobMedia.t = round2( (ltbs$Pob_Total_t+ltbs$Pob_Total_t1)/2, 2 )
  Nac.Tot.suma = sum(tb_TEF$Nac.Tot)
  TBNx1000 = round2( (Nac.Tot.suma/PobMedia.t)*1000, 2)
  
  #PobMediaMuj.t = round2( mean(mean(tb_TEF$Pob.t),mean(tb_TEF$Pob.t1),2) ,2)
  PobMediaMuj.t = round2( mean(c(sum(tb_TEF$Pob.t),sum(tb_TEF$Pob.t1))) ,2)
  TGFx1000 = round2(  (Nac.Tot.suma/PobMediaMuj.t)*1000 ,2)
  
  ISFm1 = round2( ((TGFx1000)/1000) * 35   , 5)
  ISFm2 = round2( 5*(sum(tb_TEF$TEFx1000)/1000)  , 5)
  
  v_xMedia = tb_TEF %>% 
    summarise(
      xMedia = round2(  sum(Marcasx*TEFx1000)/sum(TEFx1000)   , 2),
      xMediaNfem = round2(  sum(Marcasx*TEFfx1000)/sum(TEFfx1000)   , 2),
      xMedia1hijo = round2(  sum(Marcasx*Nac.Tot)/sum(Nac.Tot)   , 2)
      )
  xMedia = v_xMedia$xMedia
  xMediaNfem = v_xMedia$xMediaNfem
  xMedia1hijo = v_xMedia$xMedia1hijo
  #xMedia
  sex.ratio = round2( (sum(tb_TEF$Nac.Muj)/Nac.Tot.suma) , 5)
  TBRm1 = round2(ISFm2 * sex.ratio, 5)

  TBRm2 = round2( (5/1000)*sum(tb_TEF$TEFfx1000)  , 5)
  
  TNR = round2( sum(tb_TEF$TEFfx1000 * tb_TEF$nLx)/(100000*1000), 5 )

  res = list(
    tb_TEF = tb_TEF,
    PobMedia.t = PobMedia.t,
    Nac.Tot.suma = Nac.Tot.suma,
    TBNx1000 = TBNx1000,
    PobMediaMuj.t = PobMediaMuj.t,
    TGFx1000 = TGFx1000,
    ISFm1 = ISFm1,
    ISFm2 = ISFm2,
    xMedia = xMedia,
    xMediaNfem = xMediaNfem,
    xMedia1hijo =xMedia1hijo,
    sex.ratio = sex.ratio,
    TBRm1 = TBRm1,
    TBRm2 = TBRm2,
    TNR = TNR
  )
  
  return(res)
}


#s = func_temaFec_ejerc01(ej1)


# Función que resuelve el problema del ejercicio 3 de fecundidad ------
func_temaFec_ejerc03 = function(l_tbs_Fec_ej01) {
  
  ej1 = l_tbs_Fec_ej01
  # Gtb01b = cbind(ej1$tb_Nacim[,c(1,4,6)],ej1$tb_Pob_Muj$Pob.t,ej1$tb_psuperv_Muj$psupx)
  # Gtb01 = cbind(ej1$tb_Nacim[,c(1,2,3,4,6)],ej1$tb_Pob_Muj$Pob.t,ej1$tb_psuperv_Muj$psupx)
  
  Gtb01 = bind_cols(
    ej1$tb_Nacim %>% 
      select(1,2,3,4,6),
    ej1$tb_Pob_Muj %>% 
      select(Pob.t),
    ej1$tb_psuperv_Muj %>% 
      select(psupx)
  )
  Gtb01b = Gtb01 %>% 
    select(-GEdad.iz,-GEdad.de)
    
  #ltbs2 = dplyr::bind_cols(ltbs$tb_Nacim,ltbs$tb_Pob_Muj %>% select(-1),ltbs$tb_nLx_Muj %>% select(-1))
  ltbs2 = Gtb01
  
  tb_TEF = ltbs2 %>% 
    mutate(
      Marcasx = round2( (GEdad.iz+GEdad.de+1)/2 , 1),
      PMediaMujx = round2( (Pob.t), 2),
      TEFx1000 = round2( (Nac.Tot/PMediaMujx) * 1000, 2),
      TEFfx1000 = round2( (Nac.Muj/PMediaMujx) * 1000, 2)
    ) %>% 
    select(-2,-3)
  
#  PobMedia.t = round2( (ltbs$Pob_Total_t+ltbs$Pob_Total_t1)/2, 2 )
  Nac.Tot.suma = sum(tb_TEF$Nac.Tot)
#  TBNx1000 = round2( (Nac.Tot.suma/PobMedia.t)*1000, 2)
  
  #PobMediaMuj.t = round2( mean(tb_TEF$Pob.t) ,2)
  PobMediaMuj.t = round2( sum(tb_TEF$Pob.t)  ,2)

  TGFx1000 = round2(  (Nac.Tot.suma/PobMediaMuj.t)*1000 ,2)
  
  ISFm1 = round2( ((TGFx1000)/1000) * 35   , 5)
  ISFm2 = round2( 5*(sum(tb_TEF$TEFx1000)/1000)  , 5)
  
  v_xMedia = tb_TEF %>% 
    summarise(
      xMedia = round2(  sum(Marcasx*TEFx1000)/sum(TEFx1000)   , 2),
      xMediaNfem = round2(  sum(Marcasx*TEFfx1000)/sum(TEFfx1000)   , 2),
      xMedia1hijo = round2(  sum(Marcasx*Nac.Tot)/sum(Nac.Tot)   , 2)
    )
  xMedia = v_xMedia$xMedia
  xMediaNfem = v_xMedia$xMediaNfem
  xMedia1hijo = v_xMedia$xMedia1hijo
  #xMedia
  sex.ratio = round2( (sum(tb_TEF$Nac.Muj)/Nac.Tot.suma) , 5)
  TBRm1 = round2(ISFm2 * sex.ratio, 5)
  
  TBRm2 = round2( (5/1000)*sum(tb_TEF$TEFfx1000)  , 5)
  
  TNR = round2( sum(tb_TEF$TEFfx1000 * tb_TEF$psupx) * (0.005), 5 )
  
  res = list(
    tb_TEF = tb_TEF,
    Nac.Tot.suma = Nac.Tot.suma,
    PobMediaMuj.t = PobMediaMuj.t,
    TGFx1000 = TGFx1000,
    ISFm1 = ISFm1,
    ISFm2 = ISFm2,
    xMedia = xMedia,
    xMediaNfem = xMediaNfem,
    xMedia1hijo =xMedia1hijo,
    sex.ratio = sex.ratio,
    TBRm1 = TBRm1,
    TBRm2 = TBRm2,
    TNR = TNR
  )
  
  return(res)
}


#s = func_temaFec_ejerc03(ej1)
