library("exams")
oopt <- options(device.ask.default = FALSE, 
                exams_tex = "tools") # exams_tex = "tinytex"  # CUANDO SE CREAN PDF

source("modelos/funciones_utiles.R")
### se ve bien todo, salvo en el navegador Google Chrome que son las expresiones matemáticas

# En safari y firefox se ven bien tabla gráfica y expresiones matemáticas: 
#  html igual que blackboard en los demás

# LUEGO MEJOR OPCIÓN ES USAR: FIREFOX o SAFARI
# EN WINDOWS NAVEGADORES NO FUNCIONA EN EL NUEVO (MICROSOFT EDGE) Y NI CON INTERNET EXPLORER


# PASO 1: CAMBIAR LOS VALORES DE LAS SIGUIENTES OPCIONES -------------
# Cambiar la semilla cuando se quieren generar una colección diferente
semilla = 1234  
# cuántos exámenes distintos se generan 
#   (2 o 3 para las pruebas iniciales, 
#     luego un valor relacionado con el número de alumnos)
numcopias = 3
# número de intentos que tiene el alumno para realizar el examen
numintentos = 1 
# nombre de los ficheros que se generan
nombreexamen = "examen_pruebainicial_20200505_BB" 
# qué salidas: 
VsalidaHTML = TRUE  # FALSE
VsalidaPDF = FALSE # FALSE
# Personalizar:
Vfecha = "2020-05-05"
# LOS SIGUIENTES NO SE RECOMIENDA MODIFICARLOS
# directorios:
## directorio "dir"
Vdir = "exagenerados"
  Vedir = "bancopreguntas"
Vsdir = "exagenerados_extras"
Vtexdir = "exagenerados_latex"
if (!file.exists(Vedir)) {
  #unlink(Vedir,recursive = TRUE)
  dir.create(Vedir)
}  
if (!file.exists(Vsdir)) {
  #unlink(Vsdir,recursive = TRUE)
  dir.create(Vsdir)
}  
if (!file.exists(Vsdir)) {
  #unlink(Vsdir,recursive = TRUE)
  dir.create(Vsdir)
} else {
  unlink(Vsdir,recursive = TRUE)
  dir.create(Vsdir)
}  




# PASO 2: Selección de preguntas -----------
# Se completará con los nombres de ficheros que contienen las preguntas que
# se quieren incluir en el examen con el camino relativo desde la carpeta 
# "examsconRmd"

miexamen = list(
  # Pregunta 1
  "bancopreguntas/estadistica/QEstBasica1_schoice.Rmd",
  # Pregunta 2
  "bancopreguntas/estadistica/QEstBasica2_schoice.Rmd",
  # Pregunta 3
  "bancopreguntas/estadistica/QEstBasica3_num.Rmd",
  # Pregunta 4
  "bancopreguntas/estadistica/QEstBasica4_num.Rmd",
  # Pregunta 5
  "bancopreguntas/estadistica/QEstBasica5_schoice.Rmd",
  # Pregunta 6
  "bancopreguntas/estadistica/QEstBasica6_schoice.Rmd",
  # Pregunta 7
  "bancopreguntas/estadistica/QEstBasica7_schoice.Rmd",
  # Pregunta 8
  "bancopreguntas/estadistica/QEstBasica8_schoice.Rmd"
)

# PASO 3: PULSAR EL BOTÓN DE LA PARTE SUPERIOR DERECHA: "Source" 
###         PARA GENERAR TODOS LOS EXÁMENES


## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## 
## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## 
## NO ES NECESARIO MODIFICAR LOS SIGUIENTES APARTADOS
## ÚNICAMENTE SE PODRÍA BORRAR EL CÓDIGO DE UNA DE LAS SALIDAS AUXILIARES: PDF O HTML
## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## 



# Creación del examen en formato Blackboard ----------------
fmt_salida <<- "html"
set.seed(semilla)

suppressWarnings(
exams2blackboard(miexamen, 
     n = numcopias, # cuántos exámenes distintos que se generan (relacionado con el número de alumnos)
     name = paste0(nombreexamen,"BBEV"), # nombre del fichero zip que se genera
     dir = Vdir,  # directorio donde se colocarán los ficheros generados FINALES
     edir = Vedir, # directorio principal del banco de preguntas
     sdir=Vsdir, # directorio donde se colocarán los ficheros extras generados relacionados con los ejercicios incluidos
     tdescription = '<b>El fin de este examen es únicamente para hacer pruebas del 
     funcionamiento de las herramientas para exámenes on line de Blackboard. NO TIENE NINGÚN
     VALOR EN LA EVALUACIÓN DE ESTA ASIGNATURA. 
     NAVEGADORES RECOMENDADOS: FIREFOX Y SAFARI</b> 
     (Chrome y Navegador Microsoft no muestra correctamente expresiones matemáticas).',
     tinstruction = '<b>El examen tendrá que resolverse en PAPEL. Una vez finalizado el examen, se ESCANEARÁ
     todo lo escrito y se convertirá a formato PDF.<br>
     En la PRIMERA PÁGINA debe escribirse el nombre+apellidos, el DNI y la fecha del examen. Además,
     en esa primera página se crearán cajas de texto por cada ejercicio-apartado con la respuesta corta al ejercicio-apartado.
     En el resto de folios, se desarrollará cada uno de los ejercicios-apartados con las explicaciones
     necesarias de cómo se ha resuelto el ejercicio-apartado.<br>
     También podría solicitarse que se enviase el código utilizado.
     Si son dos ficheros los que se solicitan deben enviarse comprimidos en un único fichero.
     En caso de un único fichero PDF se enviaría este.<br> 
     El envío del fichero debe hacerse por "MENSAJES DE CURSO" (puede comprobar en su buzón de enviados que el mensaje
     se ha enviado y contiene el fichero solicitado).<br>
     EL examen tendrá una DURACIÓN LIMITADA de tiempo. Cada uno de los ejercicios
     se mostrarán UNO A UNO. <br>
     SIEMPRE SE DEBE PULSAR SOBRE EL BOTÓN DE GUARDAR LA RESPUESTA.
     Las respuestas numéricas tendrán que introducirse con LA COMA DECIMAL (",").<br>
     La calificación final se obtendrá cuando el profesorado corrija los exámenes PDF-ESCANAEADOS 
     (no tenga en cuenta la calificación automática que genera la plataforma). <br>
     UNA VEZ FINALIZADO SE PULSARÁ GUARDAR Y ENVIAR EXAMEN y se hará el envío del fichero por MENSAJES DE CURSO.</b>',
     maxattempts = numintentos  # número de intentos que tiene el alumno para realizar el examen  
)
)


# Creación del examen en formato html (con las soluciones para revisión) --------------

if (VsalidaHTML) {
fmt_salida <<- "html"  
set.seed(semilla)  # usar la misma semilla garantiza que sean los mismos ejercicios

exams2html(miexamen, 
          n = numcopias, 
          name = paste0(nombreexamen,"html"),
          dir = Vdir,   # directorio donde se colocarán los ficheros generados FINALES
          question = "<h4>Pregunta</h4>", 
          solution = "<h4>Solución</h4>",
          edir = Vedir # directorio principal del banco de preguntas
          
)

}





# Creación del examen en formato pdf (con las soluciones para revisión) --------------

if (VsalidaPDF) {
  fmt_salida <<- "latex"
  set.seed(semilla)  # usar la misma semilla garantiza que sean los mismos ejercicios
  
  exams2pdf(miexamen, 
            n = numcopias,
            # si se quiere un fichero para enunciado solo, y otro fichero para enunciado+solucion
            name = paste0(nombreexamen,c("pdf-enunciados", "pdf-soluciones")),
            # si solamente queremos enunciado+soluciones en un único fichero descomentar siguiente
            # name = paste0(nombreexamen,c("pdf-soluciones")), 
            dir = Vdir, # directorio donde se colocarán los ficheros generados FINALES
            edir = Vedir, # directorio principal del banco de preguntas
            texdir = Vtexdir, # donde se crean los ficheros latex
            template = c("modelos/tempexamnoid.tex", "modelos/tempsolutionnoid.tex"),
            header = list(
              Date = Vfecha,
              ID = function(i) formatC(i, width = 5, flag = "0")
            )
  )

}


## ----------------------------------------------------------------------------------
options(exams_tex = oopt$exams_tex)
